
/*
long int power_c(const long int val){
   return val*val;
}
*/
extern "C" long int power_long_int_asm(const long int val);
__asm__(
".global power_long_int_asm \n"
"power_long_int_asm: \n"
"imulq  %rdi, %rdi;\n"
"movq  %rdi, %rax;\n"
"ret;\n"
);

/*
double power_c(const double val){
   return val*val;
}
*/
extern "C" double power_double_asm(const double val);
__asm__(
".global power_double_asm \n"
"power_double_asm: \n"
"mulsd  %xmm0, %xmm0;\n"
"ret;\n"
".LC0_bis:\n"
".long   0\n"
".long   1072693248\n"
);



#include "utils.hpp"
#include <iostream>

int main(){
    const long int TestSize = 1000;
    
    std::cout << "Check power_long_int_asm" << std::endl;
    
    for(long int idx = 0 ; idx < TestSize ; ++idx){
        CheckEqual(idx*idx,power_long_int_asm(idx));
    }    
    
    std::cout << "Check power_double_asm" << std::endl;
    
    for(long int idx = 0 ; idx < TestSize ; ++idx){
        CheckEqual(double(idx)*double(idx),power_double_asm(double(idx)));
    }

    return 0;
}