
/*
long int axpy(const long int* vec0, const long int* vec1, const long int N){
   long int sum = 0;
   for(long int idx = 0 ; idx < N ; ++idx){
       sum += vec0[idx] * vec1[idx];
   }
   return sum;
}
*/

extern "C" long int axpy(const long int* vec0, const long int* vec1,
                             const long int N);
__asm__(
".global axpy \n"
"axpy: \n"
"testq   %rdx, %rdx \n"
"jle     .L4 \n"
"leaq    0(,%rdx,8), %rcx \n"
"xorl    %eax, %eax \n"
"xorl    %r8d, %r8d \n"
".L3: \n"
"movq    (%rdi,%rax), %rdx \n"
"imulq   (%rsi,%rax), %rdx \n"
"addq    $8, %rax \n"
"addq    %rdx, %r8 \n"
"cmpq    %rax, %rcx \n"
"jne     .L3 \n"
"movq    %r8, %rax \n"
"ret \n"
".L4: \n"   
"xorl    %r8d, %r8d \n"
"movq    %r8, %rax \n"    
"ret; \n"
);


#include "utils.hpp"
#include <iostream>
#include <random>
#include <vector>

int main(){
    const long int TestSize = 1000;
    
    std::cout << "Check axpy" << std::endl;
    
    std::random_device rd;
    std::mt19937 gen(rd());
    std::uniform_int_distribution<long int> dis(1, 10);
    
    for(long int idx = 0 ; idx < TestSize ; ++idx){
        std::vector<long int> vec0(idx);
        std::vector<long int> vec1(idx);
        
        long int currentSum = 0;
        for(long int idxVal = 0 ; idxVal < idx ; ++idxVal){
            vec0[idxVal] = dis(gen);
            vec1[idxVal] = dis(gen);
            currentSum += vec0[idxVal]*vec1[idxVal];
        }
    
        CheckEqual(currentSum,axpy(vec0.data(), vec1.data(), idx));
    }

    return 0;
}